﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MAGDLL; //new mag class
using PDFDLL; //new pdf417 class
using UfComScan;


namespace KPL
{
    public class Parser
    {
        byte[] buf1_DL;
        byte[] buf2_DL;
        byte[] buf3_DL;
       // byte[] buff = new byte[2000]; // Maximum size input buffer for PDF417.DLL -you must resize this array to the card length before sending it to the DLL.
        byte[] COMbuff = new byte[1500]; //Max zise buffer for using UfComScan.dll


        public Dictionary<string, string> MagProcess(byte[] input)
        {
            Dictionary<string, string> fields = new Dictionary<string, string>();
            Magstripe.ParseDL(input);

            fields.Add("State", Magstripe.stateP_DL);
            fields.Add("City", Magstripe.cityP_DL);
            fields.Add("Address", Magstripe.addrP_DL);
            fields.Add("FirstName", Magstripe.firstnameP_DL);
            fields.Add("MidName", Magstripe.midnameP_DL);
            fields.Add("LastName", Magstripe.lastnameP_DL);
            fields.Add("Title", Magstripe.titleP_DL);
            fields.Add("Zipcode", Magstripe.zipP_DL);
            fields.Add("DOB", Magstripe.dobMMDDP_DL + Magstripe.dobyearP_DL);
            fields.Add("DOBMMDD", Magstripe.dobMMDDP_DL);
            fields.Add("DOBYEAR", Magstripe.dobyearP_DL);
            fields.Add("Exp", Magstripe.expP_DL);
            fields.Add("Ht", Magstripe.HeightP_DL);
            fields.Add("Wt", Magstripe.WeightP_DL);
            fields.Add("Sex", Magstripe.SexP_DL);
            fields.Add("Hair", Magstripe.HairP_DL);
            fields.Add("Eye", Magstripe.EyeP_DL);
            fields.Add("Class", Magstripe.ClassP_DL);
            fields.Add("Restrict", Magstripe.RestrictionsP_DL);
            fields.Add("Endors", Magstripe.EndorsementsP_DL);
            fields.Add("ID", Magstripe.dlP_DL);
            fields.Add("Rank", string.Empty);

            return fields;
        }


        public Dictionary<string, string> PDF417Process(byte[] input)
        {
            UfComScan.UfComInfo.UnlockPDF(input, out COMbuff);
            int ret = -1;

            ret = Barcode.Parse417(COMbuff);

            Dictionary<string, string> fields = new Dictionary<string, string>();

            fields.Add("State", Barcode.State_DL);
            fields.Add("City", Barcode.City_DL);
            fields.Add("Address", Barcode.Addr_DL);
            fields.Add("FirstName", Barcode.First_DL);
            fields.Add("MidName", Barcode.Mid_DL);
            fields.Add("LastName", Barcode.Last_DL);
            fields.Add("Title", Barcode.Title_DL);
            fields.Add("Zipcode", Barcode.Zip_DL);
            fields.Add("DOB", Barcode.DobMMDD_DL + Barcode.DobYear_DL);
            fields.Add("DOBMMDD", Barcode.DobMMDD_DL);
            fields.Add("DOBYEAR", Barcode.DobYear_DL);
            fields.Add("Exp", Barcode.Exp_DL);
            fields.Add("Ht", Barcode.Height_DL);
            fields.Add("Wt", Barcode.Wt_DL);
            fields.Add("Sex", Barcode.Sex_DL);
            fields.Add("Hair", Barcode.Hair_DL);
            fields.Add("Eye", Barcode.Eye_DL);
            fields.Add("Class", Barcode.Class_DL);
            fields.Add("Restrict", Barcode.Rest_DL);
            fields.Add("Endors", Barcode.Endr_DL);
            fields.Add("ID", Barcode.Dl_DL);
            fields.Add("Rank", Barcode.Rank_DL);
            fields.Add("RET", ret.ToString());

            return fields;
        }


        private System.Array ResizeArray(System.Array oldArray, int newSize)
        {
            int oldSize = oldArray.Length;
            System.Type elementType = oldArray.GetType().GetElementType();
            System.Array newArray = System.Array.CreateInstance(elementType, newSize);
            int preserveLength = System.Math.Min(oldSize, newSize);
            if (preserveLength > 0)
                System.Array.Copy(oldArray, newArray, preserveLength);
            return newArray;
        }

        public string To_ASCII_Str(byte[] bytes)
        {
            string hexString = "";
            for (int i = 0; i < bytes.Length; i++)
            {
                if (bytes[i] == 0) break; //this should keep nulls out of strings
                hexString += (char)bytes[i];

            }
            return hexString;
        }

        public byte[] StrToByteArray(string str)
        {
            System.Text.ASCIIEncoding encoding = new System.Text.ASCIIEncoding();
            return encoding.GetBytes(str);
        }

        public byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }

    }
}
